package CyberCalendar::Auth;
###################################################################
# CyberCalendar v1.8
#
# Administrator authentication module
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@cyberweavers.com>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
use strict;

sub new {
   my $self = shift || 0;
   my $hashref = {};
   bless $hashref, $self;
}

sub authenticate {
   my $self = shift || 0;
   if ($_[0]->{session_type} == 1) { return auth_webserver($_[0], $_[1], $_[2]); }
   # if
   elsif ($_[0]->{session_type} == 2) { return auth_querystring($_[0], $_[1], $_[2]); }
   # elsif
   else { login_error("Unknown Authentication Type."); }
   #else
} # endsub authenticate

sub auth_webserver {
   #my $self = shift || 0;
   my $user = {};
   my $query = qq(SELECT uid, accesslevel from users
                  WHERE username = ?);
   $_[2]->query($query, $_[1]->{auth_user});
   my $rowcount = $_[2]->rowcount;
   if ($rowcount == 0) {
      $_[2]->finish;
      login_error("Permission Denied, no such user.");
   } # if
   else {
      $user = $_[2]->result("hashref");
      $_[2]->finish;
   } # else
   if ($user->{accesslevel} == 1) { return $user; }
   # if
   else {
      if (!exists $_[1]->{Calendar}
	  or $_[1]->{Calendar} eq '') { login_error("Permission Denied: Calendar not found."); }
      $query = qq(SELECT calendar, full_ctrl from acl
                  WHERE uid = ?
                  AND calendar = ?);
      $_[2]->query($query, $user->{uid}, $_[1]->{Calendar});
      my $rows = $_[2]->rowcount;
      if ($rows == 0) {
         $_[2]->finish;
         login_error("Permission Denied.");
      } # if
      else {
         my $result = $_[2]->result("hashref");
         $user->{calendar} = $result->{calendar};
         $user->{full_ctrl} = $result->{full_ctrl};
      } # else
      return $user;
   } # else
} # endsub auth_webserver

sub auth_querystring {
   #my $self = shift || 0;
   my $login_error = qq(&nbsp;&nbsp;&nbsp;<a href="$_[0]->{login_url}">Please login</a>);
   my $query = '';
   my $user = {};
   if (!exists $_[1]->{session}
      or $_[1]->{session} eq '') { login_error("Permission Denied.$login_error"); }
   # if
   else {
      $query = "SELECT uid, accesslevel from users
                WHERE sessionid = ?";
      $_[2]->query($query, $_[1]->{session});
      if ($_[2]->rowcount != 1) { $_[2]->finish; login_error("Permission Denied.$login_error"); }
      # if
      $user = $_[2]->result("hashref");
      $_[2]->finish;
   }
   if ($user->{accesslevel} == 1) { return $user; }
   # if
   else {
      if (!exists $_[1]->{Calendar}
	  or $_[1]->{Calendar} eq '') { login_error("Permission Denied: Calendar not found."); }
      $query = qq(SELECT calendar, full_ctrl from acl
                  WHERE uid = ?
                  AND calendar = ?);
      $_[2]->query($query, $user->{uid}, $_[1]->{Calendar});
      my $rows = $_[2]->rowcount;
      if ($rows == 0) {
         $_[2]->finish;
         login_error("Permission Denied.");
      } # if
      else {
         my $result = $_[2]->result("hashref");
         $user->{calendar} = $result->{calendar};
         $user->{full_ctrl} = $result->{full_ctrl};
      } # else
      return $user;
   }
} #endsub auth_querystring

sub login_error {
   print qq(<b><font face="Arial, Helvetica" color="red">ERROR:</font> $_[0]</b><p>\n);

   # Determine how to properly exit
   if (exists $ENV{MOD_PERL}) { Apache::exit(0); }
   # if
   else { CORE::exit(0); }
   # else
} # endsub login_error

sub DESTROY {
    my $self = shift;
    my $hashref = {};
} # endsub DESTROY
1;
