package CyberCalendar::Database;
###################################################################
# CyberCalendar v1.8.2
#
# Database Module
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@cyberweavers.com>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
# IMPORT MODULES
BEGIN {
   use vars qw($dbh $handle);
   my $module = '';
   if (exists $ENV{MOD_PERL}) { $module = 'Apache::DBI'; }
   else { $module = 'DBI'; }
   eval "use $module";
   use strict;
}
###################################################################
# Callable Methods

sub new {
   my $self = shift || 0;
   my $aryref = [];
   bless $aryref, $self;
} # endsub new

sub connect {
   my $self = shift || 0;
   $dbh ||= DBI->connect(@_) or die("\n\nERROR: Can't connect to database $DBI::errstr\n\n");
} # endsub connect

sub query {
   my $self = shift || 0;
   my $input = \@_;
   my $query = shift(@{ $input});
   $handle = $dbh->prepare($query);
   $handle->execute(@{ $input });
} # ednsub query

sub result {
   my $self = shift || 0;
   my $result_type = \@_;

SWITCH:
   for ($result_type->[0]) {
      /hashref/o && do { return $handle->fetchrow_hashref(); last; };
      /arrayref/o && do { return $handle->fetchrow_arrayref(); last; };
      /array/o && do { return $handle->fetchrow_array(); last; };
      return(0); last;
   } # for
} # endsub result

sub rowcount {
   my $self = shift || 0;
   return $handle->rows();
} # endsub rowcount

sub table_list {
   my $self = shift || 0;
   my $tables = $dbh->prepare("SHOW TABLES");
   $tables->execute();
   my @temp = map { @{ $_ } } @{ $tables->fetchall_arrayref() };
   $tables->finish;
   return @temp;
} # endsub table_list

sub finish {
   $handle->finish;
} # endsub finish

sub disconnect {
   $dbh->disconnect or warn $dbh->errstr;
} # endsub disconnect

sub DESTROY {
    my $self = shift || 0;
    my $aryref = [];
} # endsub DESTROY

1;
