package CyberCalendar::Http;
###################################################################
# CyberCalendar v1.8.2
#
# HTTP Functions Module
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@cyberweavers.com>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
# IMPORT MODULES
use vars qw(%http_in);
use strict;

###################################################################
# Callable Methods

sub new {
   my $self = shift || 0;
   my $hashref = {@_};
   bless $hashref, $self;
} # endsub new

sub header {
   my $self = shift || 0;
   my $input = {@_};
   my $data = 'text/html';
   if ($input->{type} ne '') { $data = $input->{type}; }
   else { $data = "text/html"; }
   if (exists $ENV{MOD_PERL}) { mp_header($data); }
   else { print "Content-Type: $data\n\n"; }
} # endsub header

sub mp_header {
   my $r = Apache->request;
   $r->content_type($_[0]);
   $r->send_http_header;
}

sub get_input {
   my $self = shift || 0;
   my $env = $_[0];
   my $http = '';
   %http_in = ();

   # Get HTTP input
   if ($env->{REQUEST_METHOD} eq "GET") { $http = $env->{QUERY_STRING}; }
   if ($env->{REQUEST_METHOD} eq "POST") { read(STDIN, $http, $env->{CONTENT_LENGTH}); }

   # Suck it all into an array minus &'s.
   my @pairs = split(/&/, $http);

LOOP:
   foreach (@pairs) {
      my ($name, $value) = split /=/;
      # Un-Webify
      ($name, $value) = map { unwebify($_) } ($name, $value);
      # put the GET/POST names and values into a hash.
      $http_in{$name} = $value;
   } # foreach
   # Add any other enviroment variables you may need.
   $http_in{mod_perl} = $env->{MOD_PERL} if exists $env->{MOD_PERL};
   $http_in{auth_user} = $env->{AUTH_USER} if exists $env->{AUTH_USER};
   $http_in{auth_user} = $env->{REMOTE_USER} if exists $env->{REMOTE_USER};
   $http_in{remote_addr} = $env->{REMOTE_ADDR};
   $http_in{http_user_agent} = $env->{HTTP_USER_AGENT};
   $http_in{script_name} = $env->{SCRIPT_NAME};
   $http_in{http_accept} = $env->{HTTP_ACCEPT};
   $http_in{referer} = $env->{HTTP_REFERER};
   $http_in{http_accept_language} = $env->{HTTP_ACCEPT_LANGUAGE};
   undef $env;
   undef $http;
   return \%http_in;
} # endsub get_input

sub unwebify {
   my $self = shift || 0;
   $_ =~ tr/+/ /;
   $_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   return $_;
} # endsub unwebify

sub webify {
   my $self = shift || 0;
   $_[0] =~ s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x", ord($1))/eg;
   return $_[0];
} # endsub webify

###################################################################
# Internal Subroutines


sub DESTROY {
   my $self = shift || 0;
   my $input = {@_};
} # ednsub DESTROY

1;

