package CyberCalendar::Util;
###################################################################
# CyberCalendar v1.8.2
#
# Utilities Module
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@cyberweavers.com>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
use strict;

sub new {
   my $self = shift || 0;
   my $hashref = {};
   bless $hashref, $self;
}

sub open_template {
   my $self = shift || 0;
   my $error_string = qq(<b><font face="Arial,Helvetica"><font color="red">ERROR:</font> Unable to open template file $_[1]</font></b>);
   my @template = ();
   open(FILE, "<$_[0]")
      or die(print "$error_string<b>: $!</b>\n");
   while (<FILE>) { @template = <FILE>; }
   close(FILE);
   return \@template;
}

sub sendmail {
   my $self = shift || 0;
   use MIME::Lite;
   my $msg = '';
   $msg = MIME::Lite->new(From => $_[1]->{from},
                          To => $_[1]->{to},
                          Subject => $_[1]->{subject},
                          Type => $_[1]->{Type},
                          Data => qq%$_[1]->{msg}%
                         );
   if (exists $_[1]->{attach}) {
      $msg->attach(Disposition => $_[1]->{attach_disposition},
                   Type => $_[1]->{attach_type},
                   Data => $_[1]->{attach},
                   Filename => $_[1]->{attach_filename}
                  );
   } # if
   if ($_[0] eq 'sendmail') { MIME::Lite->send("sendmail"); }
   else { MIME::Lite->send("smtp", $_[0], Timeout => 60); }
   $msg->send or die("SMTP Error: $!\n");
} # endsub sendmail

sub vcal {
   my $self =shift || 0;
   $_[1]->{desctext} =~ s/(<br>|<BR>)//g;
   $_[1]->{desctext} =~ s/\n/=0A/g;
   $_[1]->{desctext} =~ s/\r//g;
   return <<"VCAL";
BEGIN: VCALENDAR
TZ: $_[0]->{timezone}
BEGIN: VEVENT
DTSTART: $_[1]->{dateid}
DTEND: $_[1]->{enddate}
SUMMARY: $_[1]->{subject}
DESCRIPTION;QUOTED-PRINTABLE: $_[1]->{desctext}
URL: $_[0]->{calendar_homepage}$_[0]->{cal_url}?Calendar=$_[1]->{Calendar}&View=Event&DateID=$_[1]->{DateID}&Repeatid=$_[1]->{Repeatid}
UID: $_[1]->{repeatid}
END: VEVENT
END: VCALENDAR
VCAL
} # endsub vcal

sub DESTROY {
    my $self = shift || 0;
    my $input = {};
}

1;
