#!/usr/bin/perl -w
###################################################################
# CyberCalendar v1.8.2
#
# Displays event formatted for printing
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@cyberweavers.com>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
# Script Modules
use vars qw($config $db $http_in $printable);
use CyberCalendar::Application;
use strict;

###################################################################
# Begin Script

$printable = CyberCalendar::Application->new();
$printable->init();

$config = $CyberCalendar::Application::config;
$db = $CyberCalendar::Application::db;
$http_in = $CyberCalendar::Application::http_in;

show_printable();

sub show_printable {
   print "<html>\n<head>";
   CyberCalendar::Application::show_page_title("Calendar: $config->{calendar_name} Event Date: $http_in->{DateID} ID: $http_in->{Repeatid}");
   print qq(</head>\n<body bgcolor="#FFFFFF"><p align="center">);
   show_event();
   print "\n</p>\n</body>\n</html>\n";
} # endsub show_printable

sub show_event {
   my ($rows, $event) = get_event_data();
   my $cal = CyberCalendar::Calendar->new();
   my $option_link = qq(<a href="$config->{cal_url}?Calendar=$http_in->{Calendar}&View=Event&DateID=$http_in->{DateID}&Repeatid=$http_in->{Repeatid}" style="text-decoration:none">&lt;&lt;Return to Event Options</a>);
   my $date_link = qq(<a href="$config->{cal_url}?Calendar=$http_in->{Calendar}&View=Day&DateID=$http_in->{DateID}" style="text-decoration:none">&lt;&lt; Go Back</a>);
   if ($rows == 0) {
      my_error("no", "Cannot display event.");
      print qq(<br /><b><font face="$config->{event_head_font}"
                     size="$config->{event_head_font_size}">
                     $date_link</font></b><br />);
   } # if
   else {
      $cal = CyberCalendar::Calendar->new();
      my ($y, $m, $d) = split("-", $event->{dateid});
      $event->{dateid} = $cal->datestring($y, $m, $d);
      $event->{starttime} = $cal->hr24_2_hr12($event->{starttime});
      if ($event->{enddate} != 0) {
         my ($y, $m, $d) = split("-", $event->{enddate});
         $event->{enddate} = $cal->datestring($y, $m, $d);
         $event->{dateid} = "$event->{dateid} - $event->{enddate}";
      } # if
      if ($event->{endtime} != 0) {
         $event->{endtime} = $cal->hr24_2_hr12($event->{endtime});
         $event->{starttime} = "$event->{starttime} - $event->{endtime}";
      } # if
      print <<"PRINTABLE_EVENT";
<table border="0" bgcolor="#000000" width="501" cellpadding="1" cellspacing="0" align="center"><tr><td>
<table border="0" width="500" cellpadding="0" cellspacing="1" align="center" valign="center"><tr bgcolor="#FFFFFF"><td align="center">
<font face="$config->{event_head_font}" size="+1">
<b>Event:</b> $event->{subject}</font><br />
</td></tr><tr bgcolor="#FFFFFF"><td align="left">
<font face="$config->{event_head_font}" size="$config->{page_title_font_size}">
<b>Date:</b> $event->{dateid}<br />
<b>Time:</b> $event->{starttime}<br />
<b>Location:</b> $event->{location}<br />
<b>Category:</b> $event->{category}<br />
<b>Contact:</b> $event->{email}<br />
<b>Website:</b> $event->{url}<br />
<p align="justify">$event->{desctext}</p><p align="justify">
<b><font size="$config->{page_title_font_size}">Calendar: <i>$config->{calendar_name}</i>
<br />Url: <font size=2><i>$config->{calendar_homepage}$config->{cal_url}?Calendar=$http_in->{Calendar}</font></i></font></b>
</font></p>
<div align="left">
<br /><font face="$config->{event_head_font}" size="$config->{event_head_font_size}">
<b>$option_link</b></font></div>
</td></tr></table></td></tr></table>
PRINTABLE_EVENT
   } # else

} # endsub show_event

sub get_event_data {
   my $query = qq(SELECT * from $http_in->{Calendar}
                  WHERE dateid = ?
                  AND repeatid = ?);
   $db->query($query,
              CyberCalendar::Application::http2dateid($http_in->{DateID}),
              $http_in->{Repeatid});
   return ($db->rowcount, $db->result("hashref"), $db->finish);
} # endsub show_event_data

sub my_error {
 CyberCalendar::Application::my_error($_[0], $_[1]);
} # endsub my_error

$printable->my_exit();
