#!/usr/bin/perl
###################################################################
# CyberCalendar v1.8
#
# Dumps an HTML calendar from a CyberCalendar table
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@wilshire.net>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
# DESCRIPTION: This script dumps an HTML calendar into a file of your choosing.
# USAGE: ./calendar_dump_html.pl calendartable /path/to/file/filename.html

# Script Modules
use vars qw($config $http_in $db);
use CyberCalendar::Application;
use strict;

my $usage = "\n\nUSAGE: ./calendar_dump_html.pl calendartable /path/to/file/filename.html\n\n";
my $calendar = '';
my $file = '';

# Check CLI args
if ($ARGV[0] eq '' or $ARGV[1] eq '') { print $usage; exit(0); }
else { $calendar = $ARGV[0]; $file = $ARGV[1]; }

my $cal = CyberCalendar::Application->new();

$http_in->{Calendar} = $calendar;
$http_in->{DateID} = $CyberCalendar::Application::t_dateid;
$CyberCalendar::Application::http_in = $http_in;

$config = $CyberCalendar::Application::config;

CyberCalendar::Application::calendar_config($calendar);

# Do some variable massaging...
$config->{cal_url} = "$config->{calendar_homepage}$config->{cal_url}";
$config->{submit_url} = "$config->{calendar_homepage}$config->{submit_url}";
$config->{help_index} = "$config->{calendar_homepage}$config->{help_index}";
$config->{cal_img} = "$config->{calendar_homepage}$config->{cal_img}";
$config->{browse_img} = "$config->{calendar_homepage}$config->{browse_img}";
$config->{search_img} = "$config->{calendar_homepage}$config->{search_img}";
$config->{help_img} = "$config->{calendar_homepage}$config->{help_img}";

# Unbuffer STDOUT
select((select(STDOUT), $|=1)[0]);
# Redirect STDOUT
open(STDOUT, ">$file") or die(print "ERROR with file $file: $!\n");

if ($config->{show_large_calendar} == 1) {
   CyberCalendar::Application::show_large_calendar_and_data();
} # if
else {
   CyberCalendar::Application::show_calendar();
} # else
close(STDOUT);

exit(0);
