#!/usr/bin/perl
###################################################################
# CyberCalendar v1.8.2
#
# Script for optimizing MySQL tables
# Copyright 1999, 2000, 2001 Shawn Ewald <shawn@cyberweavers.com>
#
###################################################################
# License:                                                        #
# ----------------------------------------------------------------#
# This program is free software; you can redistribute it and/or   #
# modify it under the terms of the GNU General Public License     #
# as published by the Free Software Foundation; either version 2  #
# of the License, or (at your option) any later version.          #
#                                                                 #
# This program is distributed in the hope that it will be useful, #
# but WITHOUT ANY WARRANTY; without even the implied warranty of  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.            #
###################################################################
# For the full text of the GNU General Public License, go to:     #
# http://www.gnu.org/copyleft/gpl.html                            #
###################################################################
# DESCRIPTION: Optimizes MySQL Tables -- run this as a cron job.

# Script Modules
use vars qw($config $db);
use CyberCalendar::Config;
use CyberCalendar::Database;
use strict;

# Open database connection
$db = CyberCalendar::Database->new();
$db->connect($config->{datasource},
             $config->{db_user},
             $config->{db_password});

# Add table names to an array
my @tables = $db->table_list();

# Optimize each table
foreach (@tables) {
   my $query = "OPTIMIZE TABLE $_";
   $db->query($query);
   $db->finish;
   print "Optimized table $_\n";
}

# Bye bye...
$db->disconnect;
exit(0);
