# CyberCalendar data tables
#
#--------------------------------------------------------
# PLEASE SAVE A COPY OF THIS FILE BEFORE EDITING
# MAKE SURE TO AT LEAST EDIT THE DEFAULTS IN THE 'config' TABLE
#
# Usage:
# mysql -u root -p calendar < calendar.sql

#
# Table structure for table 'config'
# PLEASE EDIT THE DEFAULTS

CREATE TABLE config (
  cid int(11) NOT NULL auto_increment,
  uid int(11) DEFAULT '0' NOT NULL,
  calendar varchar(255) DEFAULT '' NOT NULL,
  is_default tinyint(1) DEFAULT '0' NOT NULL,
  timezone varchar(4) DEFAULT 'GMT' NOT NULL,
  show_large_calendar tinyint(1) DEFAULT '1' NOT NULL,
  large_calendar_width int(3) DEFAULT '595',
  show_calendars tinyint(1) DEFAULT '1' NOT NULL,
  show_days tinyint(1) DEFAULT '0' NOT NULL,
  show_lines tinyint(1) DEFAULT '0' NOT NULL,
  line_length int(2) DEFAULT '54' NOT NULL,
  site_homepage varchar(255) DEFAULT 'http://localhost/' NOT NULL,
  calendar_homepage varchar(255) DEFAULT 'http://localhost/calendar/' NOT NULL,
  template varchar(255) DEFAULT '/home/httpd/html/calendar/templates/large_calendar.html' NOT NULL,
  body_bg_color varchar(25) DEFAULT '#FFFFFF',
  body_bg_img varchar(25) DEFAULT '',
  page_title_font varchar(255) DEFAULT 'Arial,Helvetica',
  page_title_font_size char(3) DEFAULT '+1',
  page_title_var_color varchar(25) DEFAULT 'navy',
  cal_head_color varchar(25) DEFAULT '#000000',
  cal_head_text_color varchar(25) DEFAULT '#FEFEE2',
  cal_head_font varchar(255) DEFAULT 'Arial,Helvetica',
  cal_head_font_size char(3) DEFAULT '-2',
  cal_trimcolor varchar(25) DEFAULT '#CCCCCC',
  cal_bg_color varchar(25) DEFAULT '#FEFEE2',
  cal_text_color varchar(25) DEFAULT '#000000',
  cal_font varchar(25) DEFAULT 'Arial,Helvetica',
  cal_month_year_fontsize char(3) DEFAULT '2',
  cal_days_font_size char(3) DEFAULT '1',
  cal_dates_font_size char(3) DEFAULT '-2',
  featured_head_color varchar(25) DEFAULT '#FFCC00',
  featured_head_text_color varchar(25) DEFAULT '#000000',
  featured_link_color varchar(25) DEFAULT '#FFCC00',
  event_head_color varchar(25) DEFAULT '#000000',
  event_head_text_color varchar(25) DEFAULT '#FFFFFF',
  event_head_font varchar(255) DEFAULT 'Arial,Helvetica',
  event_head_font_size char(3) DEFAULT '3',
  event_body_bgcolor varchar(25) DEFAULT '#FEFEE2',
  event_body_text_color_detail varchar(25) DEFAULT '#000000',
  event_body_text_color_body varchar(25) DEFAULT 'Navy',
  event_body_font varchar(255) DEFAULT 'Arial,Helvetica',
  event_body_font_size char(3) DEFAULT '2',
  cal_img varchar(255) DEFAULT 'images/select.png',
  cal_img_alt varchar(255) DEFAULT 'Select Calendar',
  cal_img_width int(3) DEFAULT '41',
  cal_img_height int(3) DEFAULT '12',
  browse_img varchar(255) DEFAULT 'images/browse.png',
  browse_img_alt varchar(255) DEFAULT 'Browse',
  browse_img_width int(3) DEFAULT '41',
  browse_img_height int(3) DEFAULT '12',
  search_img varchar(255) DEFAULT 'images/search.png',
  search_img_alt varchar(255) DEFAULT 'Search',
  search_img_width int(3) DEFAULT '41',
  search_img_height int(3) DEFAULT '12',
  help_img varchar(255) DEFAULT 'images/help.png',
  help_img_alt varchar(255) DEFAULT 'Calendar Help',
  help_img_width int(3) DEFAULT '39',
  help_img_height int(3) DEFAULT '42',
  from_address varchar(255) DEFAULT 'calendar@localhost',
  mail_message_title varchar(255) DEFAULT 'Calendar of Events',
  html_mail_bgcolor varchar(25) DEFAULT '#FFFFFF',
  html_mail_body_font varchar(255) DEFAULT 'Arial,Helvetica',
  html_mail_body_fontsize char(3) DEFAULT '-1',
  html_mail_body_textcolor varchar(25) DEFAULT '#000000',
  public_event_submit tinyint(1) DEFAULT '0',
  public_direct_submit tinyint(1) DEFAULT '0',
  PRIMARY KEY (cid),
  KEY uid (uid),
  KEY calendar (calendar)
);

INSERT INTO config (calendar, is_default, timezone, show_large_calendar)
VALUES('rootcalendar', 1, 'EDT', 1);


#
# Table structure for table 'calendars'
#

CREATE TABLE calendars (
  cid int(11) NOT NULL auto_increment,
  uid int(11) DEFAULT '0' NOT NULL,
  gid int(11) DEFAULT '0' NOT NULL,
  site_id int(11) DEFAULT '0',
  calendar varchar(25) DEFAULT '' NOT NULL,
  name varchar(255) DEFAULT 'Calendar' NOT NULL,
  is_visible tinyint(1) DEFAULT '1' NOT NULL,
  icon varchar(255),
  description varchar(255),
  notes text,
  PRIMARY KEY (cid),
  KEY uid (uid),
  KEY calendar (calendar)
);

INSERT INTO calendars (calendar, name, is_visible)
VALUES('rootcalendar', 'Main Calendar', 1);


#
# Table structure for table 'users'
#

CREATE TABLE users (
  uid int(11) NOT NULL auto_increment,
  username varchar(25) DEFAULT '' NOT NULL,
  password varchar(25) DEFAULT '' NOT NULL,
  accesslevel tinyint(2),
  fullname varchar(255),
  email varchar(255),
  lastlogin datetime,
  lasthost varchar(16),
  sessionid varchar(31) DEFAULT '' NOT NULL,
  PRIMARY KEY (uid),
  KEY username (username),
  KEY password (password),
  KEY sessionid (sessionid)
);

INSERT INTO users (username, password, accesslevel, fullname, email)
VALUES('admin', password('caladmin1'), 1, 'Calendar Administrator', 'root@localhost');

#
# Table structure for table 'rootcalendar'
#

CREATE TABLE rootcalendar (
  eventid int(11) NOT NULL auto_increment,
  featured tinyint(1) DEFAULT '0' NOT NULL,
  repeatid varchar(25) DEFAULT '' NOT NULL,
  dateid date DEFAULT '0000-00-00' NOT NULL,
  enddate date DEFAULT '0000-00-00' NOT NULL,
  event_day int(2) DEFAULT '0' NOT NULL,
  event_month int(2) DEFAULT '0' NOT NULL,
  event_year year(4) DEFAULT '0000' NOT NULL,
  subject varchar(255) DEFAULT '' NOT NULL,
  desctext text,
  url varchar(255),
  email varchar(255),
  location varchar(255),
  category varchar(255),
  othertime char(3),
  starttime time,
  endtime time,
  image varchar(255),
  PRIMARY KEY (eventid),
  KEY repeatid (repeatid),
  KEY dateid (dateid)
);


#
# Table structure for table 'reminders'
#

CREATE TABLE reminders (
  rid int(11) NOT NULL auto_increment,
  calendar varchar(255) DEFAULT '' NOT NULL,
  remindid date DEFAULT '0000-00-00' NOT NULL,
  dateid date DEFAULT '0000-00-00' NOT NULL,
  repeatid varchar(31) DEFAULT '' NOT NULL,
  email varchar(255) DEFAULT '' NOT NULL,
  html char(3),
  PRIMARY KEY (rid),
  KEY calendar (calendar),
  KEY repeatid (repeatid)
);

#
# Table structure for table 'submitted_events'
#

CREATE TABLE submitted_events (
  eventid int(11) NOT NULL DEFAULT '0' auto_increment,
  site_id int(11) DEFAULT '0' NOT NULL,
  calendar varchar(255) DEFAULT '' NOT NULL,
  sub_name varchar(255) DEFAULT '',
  sub_email varchar(255) DEFAULT '',
  repeatid varchar(25) DEFAULT '' NOT NULL,
  dateid date DEFAULT '0000-00-00' NOT NULL,
  enddate date DEFAULT '0000-00-00' NOT NULL,
  event_day int(2) DEFAULT '0' NOT NULL,
  event_month int(2) DEFAULT '0' NOT NULL,
  event_year year(4) DEFAULT '0000' NOT NULL,
  subject varchar(255) DEFAULT '' NOT NULL,
  desctext text,
  url varchar(255),
  email varchar(255),
  location varchar(255),
  category varchar(255),
  starttime time,
  endtime time,
  PRIMARY KEY (eventid),
  KEY repeatid (repeatid),
  KEY dateid (dateid)
);

#
# Table structure for table 'acl'

CREATE TABLE acl (
  aclid int(11) NOT NULL auto_increment,
  uid int(11) DEFAULT '0' NOT NULL,
  gid int(11) DEFAULT '0' NOT NULL,
  grp varchar(25) DEFAULT '' NOT NULL,
  calendar varchar(255) DEFAULT '' NOT NULL,
  can_change tinyint(1) DEFAULT '0',
  can_del tinyint(1) DEFAULT '0',
  can_filter tinyint(1) DEFAULT '0',
  full_ctrl tinyint(1) DEFAULT '0',
  PRIMARY KEY (aclid),
  KEY uid (uid),
  KEY calendar (calendar)
);
